unit schComisionesClient_Intf;

interface

uses
  Classes, DB, schBase_Intf, SysUtils, uROClasses, uDADataTable, FmtBCD, uROXMLIntf;

const
  { Data table rules ids
       Feel free to change them to something more human readable
       but make sure they are unique in the context of your application }
  RID_Facturas_Comision = '{92237EE8-834B-480A-BECB-CC186D855782}';
  RID_Vendedores_Comision = '{B7ECCE40-B69A-4112-9328-B46B1906ABD5}';
  RID_Comisiones = '{7BAED95D-EB8C-44C7-8818-92A6E358CB24}';

  { Data table names }
  nme_Facturas_Comision = 'Facturas_Comision';
  nme_Vendedores_Comision = 'Vendedores_Comision';
  nme_Comisiones = 'Comisiones';

  { Facturas_Comision fields }
  fld_Facturas_ComisionID = 'ID';
  fld_Facturas_ComisionID_EMPRESA = 'ID_EMPRESA';
  fld_Facturas_ComisionREFERENCIA = 'REFERENCIA';
  fld_Facturas_ComisionTIPO = 'TIPO';
  fld_Facturas_ComisionID_COMISION_LIQUIDADA = 'ID_COMISION_LIQUIDADA';
  fld_Facturas_ComisionFECHA_FACTURA = 'FECHA_FACTURA';
  fld_Facturas_ComisionSITUACION = 'SITUACION';
  fld_Facturas_ComisionBASE_IMPONIBLE = 'BASE_IMPONIBLE';
  fld_Facturas_ComisionDESCUENTO = 'DESCUENTO';
  fld_Facturas_ComisionIMPORTE_DESCUENTO = 'IMPORTE_DESCUENTO';
  fld_Facturas_ComisionIVA = 'IVA';
  fld_Facturas_ComisionIMPORTE_IVA = 'IMPORTE_IVA';
  fld_Facturas_ComisionRE = 'RE';
  fld_Facturas_ComisionIMPORTE_RE = 'IMPORTE_RE';
  fld_Facturas_ComisionIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_Facturas_ComisionOBSERVACIONES = 'OBSERVACIONES';
  fld_Facturas_ComisionID_CLIENTE = 'ID_CLIENTE';
  fld_Facturas_ComisionNOMBRE_CLIENTE = 'NOMBRE_CLIENTE';
  fld_Facturas_ComisionNOMBRE_COMERCIAL_CLIENTE = 'NOMBRE_COMERCIAL_CLIENTE';
  fld_Facturas_ComisionNIF_CIF = 'NIF_CIF';
  fld_Facturas_ComisionNOMBRE = 'NOMBRE';
  fld_Facturas_ComisionCALLE = 'CALLE';
  fld_Facturas_ComisionPOBLACION = 'POBLACION';
  fld_Facturas_ComisionPROVINCIA = 'PROVINCIA';
  fld_Facturas_ComisionCODIGO_POSTAL = 'CODIGO_POSTAL';
  fld_Facturas_ComisionFECHA_ALTA = 'FECHA_ALTA';
  fld_Facturas_ComisionFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_Facturas_ComisionUSUARIO = 'USUARIO';
  fld_Facturas_ComisionID_FORMA_PAGO = 'ID_FORMA_PAGO';
  fld_Facturas_ComisionRECARGO_EQUIVALENCIA = 'RECARGO_EQUIVALENCIA';
  fld_Facturas_ComisionID_TIPO_IVA = 'ID_TIPO_IVA';
  fld_Facturas_ComisionIMPORTE_NETO = 'IMPORTE_NETO';
  fld_Facturas_ComisionIMPORTE_PORTE = 'IMPORTE_PORTE';
  fld_Facturas_ComisionID_AGENTE = 'ID_AGENTE';
  fld_Facturas_ComisionREFERENCIA_COMISION = 'REFERENCIA_COMISION';
  fld_Facturas_ComisionIGNORAR_CONTABILIDAD = 'IGNORAR_CONTABILIDAD';
  fld_Facturas_ComisionID_TIENDA = 'ID_TIENDA';
  fld_Facturas_ComisionTIENDA = 'TIENDA';
  fld_Facturas_ComisionID_SUBCUENTA = 'ID_SUBCUENTA';
  fld_Facturas_ComisionSUBCUENTA = 'SUBCUENTA';

  { Facturas_Comision field indexes }
  idx_Facturas_ComisionID = 0;
  idx_Facturas_ComisionID_EMPRESA = 1;
  idx_Facturas_ComisionREFERENCIA = 2;
  idx_Facturas_ComisionTIPO = 3;
  idx_Facturas_ComisionID_COMISION_LIQUIDADA = 4;
  idx_Facturas_ComisionFECHA_FACTURA = 5;
  idx_Facturas_ComisionSITUACION = 6;
  idx_Facturas_ComisionBASE_IMPONIBLE = 7;
  idx_Facturas_ComisionDESCUENTO = 8;
  idx_Facturas_ComisionIMPORTE_DESCUENTO = 9;
  idx_Facturas_ComisionIVA = 10;
  idx_Facturas_ComisionIMPORTE_IVA = 11;
  idx_Facturas_ComisionRE = 12;
  idx_Facturas_ComisionIMPORTE_RE = 13;
  idx_Facturas_ComisionIMPORTE_TOTAL = 14;
  idx_Facturas_ComisionOBSERVACIONES = 15;
  idx_Facturas_ComisionID_CLIENTE = 16;
  idx_Facturas_ComisionNOMBRE_CLIENTE = 17;
  idx_Facturas_ComisionNOMBRE_COMERCIAL_CLIENTE = 18;
  idx_Facturas_ComisionNIF_CIF = 19;
  idx_Facturas_ComisionNOMBRE = 20;
  idx_Facturas_ComisionCALLE = 21;
  idx_Facturas_ComisionPOBLACION = 22;
  idx_Facturas_ComisionPROVINCIA = 23;
  idx_Facturas_ComisionCODIGO_POSTAL = 24;
  idx_Facturas_ComisionFECHA_ALTA = 25;
  idx_Facturas_ComisionFECHA_MODIFICACION = 26;
  idx_Facturas_ComisionUSUARIO = 27;
  idx_Facturas_ComisionID_FORMA_PAGO = 28;
  idx_Facturas_ComisionRECARGO_EQUIVALENCIA = 29;
  idx_Facturas_ComisionID_TIPO_IVA = 30;
  idx_Facturas_ComisionIMPORTE_NETO = 31;
  idx_Facturas_ComisionIMPORTE_PORTE = 32;
  idx_Facturas_ComisionID_AGENTE = 33;
  idx_Facturas_ComisionREFERENCIA_COMISION = 34;
  idx_Facturas_ComisionIGNORAR_CONTABILIDAD = 35;
  idx_Facturas_ComisionID_TIENDA = 36;
  idx_Facturas_ComisionTIENDA = 37;
  idx_Facturas_ComisionID_SUBCUENTA = 38;
  idx_Facturas_ComisionSUBCUENTA = 39;

  { Vendedores_Comision fields }
  fld_Vendedores_ComisionID = 'ID';
  fld_Vendedores_ComisionID_COMISION = 'ID_COMISION';
  fld_Vendedores_ComisionID_VENDEDOR = 'ID_VENDEDOR';
  fld_Vendedores_ComisionNOMBRE = 'NOMBRE';
  fld_Vendedores_ComisionCOMISION = 'COMISION';
  fld_Vendedores_ComisionIMPORTE_TOTAL = 'IMPORTE_TOTAL';

  { Vendedores_Comision field indexes }
  idx_Vendedores_ComisionID = 0;
  idx_Vendedores_ComisionID_COMISION = 1;
  idx_Vendedores_ComisionID_VENDEDOR = 2;
  idx_Vendedores_ComisionNOMBRE = 3;
  idx_Vendedores_ComisionCOMISION = 4;
  idx_Vendedores_ComisionIMPORTE_TOTAL = 5;

  { Comisiones fields }
  fld_ComisionesID = 'ID';
  fld_ComisionesID_EMPRESA = 'ID_EMPRESA';
  fld_ComisionesREFERENCIA = 'REFERENCIA';
  fld_ComisionesID_AGENTE = 'ID_AGENTE';
  fld_ComisionesDESCRIPCION = 'DESCRIPCION';
  fld_ComisionesFECHA = 'FECHA';
  fld_ComisionesIMPORTE_TOTAL = 'IMPORTE_TOTAL';
  fld_ComisionesFECHA_ALTA = 'FECHA_ALTA';
  fld_ComisionesFECHA_MODIFICACION = 'FECHA_MODIFICACION';
  fld_ComisionesUSUARIO = 'USUARIO';

  { Comisiones field indexes }
  idx_ComisionesID = 0;
  idx_ComisionesID_EMPRESA = 1;
  idx_ComisionesREFERENCIA = 2;
  idx_ComisionesID_AGENTE = 3;
  idx_ComisionesDESCRIPCION = 4;
  idx_ComisionesFECHA = 5;
  idx_ComisionesIMPORTE_TOTAL = 6;
  idx_ComisionesFECHA_ALTA = 7;
  idx_ComisionesFECHA_MODIFICACION = 8;
  idx_ComisionesUSUARIO = 9;

type
  { IFacturas_Comision }
  IFacturas_Comision = interface(IDAStronglyTypedDataTable)
  ['{601DB2B1-3514-4B82-9EB8-74AA3059A345}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_EMPRESAIsNull: Boolean;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetTIPOValue: String;
    procedure SetTIPOValue(const aValue: String);
    function GetTIPOIsNull: Boolean;
    procedure SetTIPOIsNull(const aValue: Boolean);
    function GetID_COMISION_LIQUIDADAValue: Integer;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
    function GetID_COMISION_LIQUIDADAIsNull: Boolean;
    procedure SetID_COMISION_LIQUIDADAIsNull(const aValue: Boolean);
    function GetFECHA_FACTURAValue: DateTime;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime);
    function GetFECHA_FACTURAIsNull: Boolean;
    procedure SetFECHA_FACTURAIsNull(const aValue: Boolean);
    function GetSITUACIONValue: String;
    procedure SetSITUACIONValue(const aValue: String);
    function GetSITUACIONIsNull: Boolean;
    procedure SetSITUACIONIsNull(const aValue: Boolean);
    function GetBASE_IMPONIBLEValue: Currency;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency);
    function GetBASE_IMPONIBLEIsNull: Boolean;
    procedure SetBASE_IMPONIBLEIsNull(const aValue: Boolean);
    function GetDESCUENTOValue: Float;
    procedure SetDESCUENTOValue(const aValue: Float);
    function GetDESCUENTOIsNull: Boolean;
    procedure SetDESCUENTOIsNull(const aValue: Boolean);
    function GetIMPORTE_DESCUENTOValue: Currency;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency);
    function GetIMPORTE_DESCUENTOIsNull: Boolean;
    procedure SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean);
    function GetIVAValue: Float;
    procedure SetIVAValue(const aValue: Float);
    function GetIVAIsNull: Boolean;
    procedure SetIVAIsNull(const aValue: Boolean);
    function GetIMPORTE_IVAValue: Currency;
    procedure SetIMPORTE_IVAValue(const aValue: Currency);
    function GetIMPORTE_IVAIsNull: Boolean;
    procedure SetIMPORTE_IVAIsNull(const aValue: Boolean);
    function GetREValue: Float;
    procedure SetREValue(const aValue: Float);
    function GetREIsNull: Boolean;
    procedure SetREIsNull(const aValue: Boolean);
    function GetIMPORTE_REValue: Currency;
    procedure SetIMPORTE_REValue(const aValue: Currency);
    function GetIMPORTE_REIsNull: Boolean;
    procedure SetIMPORTE_REIsNull(const aValue: Boolean);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetIMPORTE_TOTALIsNull: Boolean;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean);
    function GetOBSERVACIONESValue: IROStrings;
    function GetOBSERVACIONESIsNull: Boolean;
    procedure SetOBSERVACIONESIsNull(const aValue: Boolean);
    function GetID_CLIENTEValue: Integer;
    procedure SetID_CLIENTEValue(const aValue: Integer);
    function GetID_CLIENTEIsNull: Boolean;
    procedure SetID_CLIENTEIsNull(const aValue: Boolean);
    function GetNOMBRE_CLIENTEValue: String;
    procedure SetNOMBRE_CLIENTEValue(const aValue: String);
    function GetNOMBRE_CLIENTEIsNull: Boolean;
    procedure SetNOMBRE_CLIENTEIsNull(const aValue: Boolean);
    function GetNOMBRE_COMERCIAL_CLIENTEValue: String;
    procedure SetNOMBRE_COMERCIAL_CLIENTEValue(const aValue: String);
    function GetNOMBRE_COMERCIAL_CLIENTEIsNull: Boolean;
    procedure SetNOMBRE_COMERCIAL_CLIENTEIsNull(const aValue: Boolean);
    function GetNIF_CIFValue: String;
    procedure SetNIF_CIFValue(const aValue: String);
    function GetNIF_CIFIsNull: Boolean;
    procedure SetNIF_CIFIsNull(const aValue: Boolean);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetNOMBREIsNull: Boolean;
    procedure SetNOMBREIsNull(const aValue: Boolean);
    function GetCALLEValue: String;
    procedure SetCALLEValue(const aValue: String);
    function GetCALLEIsNull: Boolean;
    procedure SetCALLEIsNull(const aValue: Boolean);
    function GetPOBLACIONValue: String;
    procedure SetPOBLACIONValue(const aValue: String);
    function GetPOBLACIONIsNull: Boolean;
    procedure SetPOBLACIONIsNull(const aValue: Boolean);
    function GetPROVINCIAValue: String;
    procedure SetPROVINCIAValue(const aValue: String);
    function GetPROVINCIAIsNull: Boolean;
    procedure SetPROVINCIAIsNull(const aValue: Boolean);
    function GetCODIGO_POSTALValue: String;
    procedure SetCODIGO_POSTALValue(const aValue: String);
    function GetCODIGO_POSTALIsNull: Boolean;
    procedure SetCODIGO_POSTALIsNull(const aValue: Boolean);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_ALTAIsNull: Boolean;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONIsNull: Boolean;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetUSUARIOIsNull: Boolean;
    procedure SetUSUARIOIsNull(const aValue: Boolean);
    function GetID_FORMA_PAGOValue: Integer;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer);
    function GetID_FORMA_PAGOIsNull: Boolean;
    procedure SetID_FORMA_PAGOIsNull(const aValue: Boolean);
    function GetRECARGO_EQUIVALENCIAValue: SmallInt;
    procedure SetRECARGO_EQUIVALENCIAValue(const aValue: SmallInt);
    function GetRECARGO_EQUIVALENCIAIsNull: Boolean;
    procedure SetRECARGO_EQUIVALENCIAIsNull(const aValue: Boolean);
    function GetID_TIPO_IVAValue: Integer;
    procedure SetID_TIPO_IVAValue(const aValue: Integer);
    function GetID_TIPO_IVAIsNull: Boolean;
    procedure SetID_TIPO_IVAIsNull(const aValue: Boolean);
    function GetIMPORTE_NETOValue: Currency;
    procedure SetIMPORTE_NETOValue(const aValue: Currency);
    function GetIMPORTE_NETOIsNull: Boolean;
    procedure SetIMPORTE_NETOIsNull(const aValue: Boolean);
    function GetIMPORTE_PORTEValue: Currency;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency);
    function GetIMPORTE_PORTEIsNull: Boolean;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean);
    function GetID_AGENTEValue: Integer;
    procedure SetID_AGENTEValue(const aValue: Integer);
    function GetID_AGENTEIsNull: Boolean;
    procedure SetID_AGENTEIsNull(const aValue: Boolean);
    function GetREFERENCIA_COMISIONValue: String;
    procedure SetREFERENCIA_COMISIONValue(const aValue: String);
    function GetREFERENCIA_COMISIONIsNull: Boolean;
    procedure SetREFERENCIA_COMISIONIsNull(const aValue: Boolean);
    function GetIGNORAR_CONTABILIDADValue: SmallInt;
    procedure SetIGNORAR_CONTABILIDADValue(const aValue: SmallInt);
    function GetIGNORAR_CONTABILIDADIsNull: Boolean;
    procedure SetIGNORAR_CONTABILIDADIsNull(const aValue: Boolean);
    function GetID_TIENDAValue: Integer;
    procedure SetID_TIENDAValue(const aValue: Integer);
    function GetID_TIENDAIsNull: Boolean;
    procedure SetID_TIENDAIsNull(const aValue: Boolean);
    function GetTIENDAValue: String;
    procedure SetTIENDAValue(const aValue: String);
    function GetTIENDAIsNull: Boolean;
    procedure SetTIENDAIsNull(const aValue: Boolean);
    function GetID_SUBCUENTAValue: Integer;
    procedure SetID_SUBCUENTAValue(const aValue: Integer);
    function GetID_SUBCUENTAIsNull: Boolean;
    procedure SetID_SUBCUENTAIsNull(const aValue: Boolean);
    function GetSUBCUENTAValue: String;
    procedure SetSUBCUENTAValue(const aValue: String);
    function GetSUBCUENTAIsNull: Boolean;
    procedure SetSUBCUENTAIsNull(const aValue: Boolean);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property TIPOIsNull: Boolean read GetTIPOIsNull write SetTIPOIsNull;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property ID_COMISION_LIQUIDADAIsNull: Boolean read GetID_COMISION_LIQUIDADAIsNull write SetID_COMISION_LIQUIDADAIsNull;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property FECHA_FACTURAIsNull: Boolean read GetFECHA_FACTURAIsNull write SetFECHA_FACTURAIsNull;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property SITUACIONIsNull: Boolean read GetSITUACIONIsNull write SetSITUACIONIsNull;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property BASE_IMPONIBLEIsNull: Boolean read GetBASE_IMPONIBLEIsNull write SetBASE_IMPONIBLEIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IMPORTE_DESCUENTOIsNull: Boolean read GetIMPORTE_DESCUENTOIsNull write SetIMPORTE_DESCUENTOIsNull;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IVAIsNull: Boolean read GetIVAIsNull write SetIVAIsNull;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property IMPORTE_IVAIsNull: Boolean read GetIMPORTE_IVAIsNull write SetIMPORTE_IVAIsNull;
    property RE: Float read GetREValue write SetREValue;
    property REIsNull: Boolean read GetREIsNull write SetREIsNull;
    property IMPORTE_RE: Currency read GetIMPORTE_REValue write SetIMPORTE_REValue;
    property IMPORTE_REIsNull: Boolean read GetIMPORTE_REIsNull write SetIMPORTE_REIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue;
    property OBSERVACIONESIsNull: Boolean read GetOBSERVACIONESIsNull write SetOBSERVACIONESIsNull;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property ID_CLIENTEIsNull: Boolean read GetID_CLIENTEIsNull write SetID_CLIENTEIsNull;
    property NOMBRE_CLIENTE: String read GetNOMBRE_CLIENTEValue write SetNOMBRE_CLIENTEValue;
    property NOMBRE_CLIENTEIsNull: Boolean read GetNOMBRE_CLIENTEIsNull write SetNOMBRE_CLIENTEIsNull;
    property NOMBRE_COMERCIAL_CLIENTE: String read GetNOMBRE_COMERCIAL_CLIENTEValue write SetNOMBRE_COMERCIAL_CLIENTEValue;
    property NOMBRE_COMERCIAL_CLIENTEIsNull: Boolean read GetNOMBRE_COMERCIAL_CLIENTEIsNull write SetNOMBRE_COMERCIAL_CLIENTEIsNull;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NIF_CIFIsNull: Boolean read GetNIF_CIFIsNull write SetNIF_CIFIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property CALLEIsNull: Boolean read GetCALLEIsNull write SetCALLEIsNull;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property POBLACIONIsNull: Boolean read GetPOBLACIONIsNull write SetPOBLACIONIsNull;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PROVINCIAIsNull: Boolean read GetPROVINCIAIsNull write SetPROVINCIAIsNull;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property CODIGO_POSTALIsNull: Boolean read GetCODIGO_POSTALIsNull write SetCODIGO_POSTALIsNull;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull: Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull: Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID_FORMA_PAGOIsNull: Boolean read GetID_FORMA_PAGOIsNull write SetID_FORMA_PAGOIsNull;
    property RECARGO_EQUIVALENCIA: SmallInt read GetRECARGO_EQUIVALENCIAValue write SetRECARGO_EQUIVALENCIAValue;
    property RECARGO_EQUIVALENCIAIsNull: Boolean read GetRECARGO_EQUIVALENCIAIsNull write SetRECARGO_EQUIVALENCIAIsNull;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property ID_TIPO_IVAIsNull: Boolean read GetID_TIPO_IVAIsNull write SetID_TIPO_IVAIsNull;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_NETOIsNull: Boolean read GetIMPORTE_NETOIsNull write SetIMPORTE_NETOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property ID_AGENTEIsNull: Boolean read GetID_AGENTEIsNull write SetID_AGENTEIsNull;
    property REFERENCIA_COMISION: String read GetREFERENCIA_COMISIONValue write SetREFERENCIA_COMISIONValue;
    property REFERENCIA_COMISIONIsNull: Boolean read GetREFERENCIA_COMISIONIsNull write SetREFERENCIA_COMISIONIsNull;
    property IGNORAR_CONTABILIDAD: SmallInt read GetIGNORAR_CONTABILIDADValue write SetIGNORAR_CONTABILIDADValue;
    property IGNORAR_CONTABILIDADIsNull: Boolean read GetIGNORAR_CONTABILIDADIsNull write SetIGNORAR_CONTABILIDADIsNull;
    property ID_TIENDA: Integer read GetID_TIENDAValue write SetID_TIENDAValue;
    property ID_TIENDAIsNull: Boolean read GetID_TIENDAIsNull write SetID_TIENDAIsNull;
    property TIENDA: String read GetTIENDAValue write SetTIENDAValue;
    property TIENDAIsNull: Boolean read GetTIENDAIsNull write SetTIENDAIsNull;
    property ID_SUBCUENTA: Integer read GetID_SUBCUENTAValue write SetID_SUBCUENTAValue;
    property ID_SUBCUENTAIsNull: Boolean read GetID_SUBCUENTAIsNull write SetID_SUBCUENTAIsNull;
    property SUBCUENTA: String read GetSUBCUENTAValue write SetSUBCUENTAValue;
    property SUBCUENTAIsNull: Boolean read GetSUBCUENTAIsNull write SetSUBCUENTAIsNull;
  end;

  { TFacturas_ComisionDataTableRules }
  TFacturas_ComisionDataTableRules = class(TIntfObjectDADataTableRules, IFacturas_Comision)
  private
    f_OBSERVACIONES: IROStrings;
    procedure OBSERVACIONES_OnChange(Sender: TObject);
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetTIPOValue: String; virtual;
    procedure SetTIPOValue(const aValue: String); virtual;
    function GetTIPOIsNull: Boolean; virtual;
    procedure SetTIPOIsNull(const aValue: Boolean); virtual;
    function GetID_COMISION_LIQUIDADAValue: Integer; virtual;
    procedure SetID_COMISION_LIQUIDADAValue(const aValue: Integer); virtual;
    function GetID_COMISION_LIQUIDADAIsNull: Boolean; virtual;
    procedure SetID_COMISION_LIQUIDADAIsNull(const aValue: Boolean); virtual;
    function GetFECHA_FACTURAValue: DateTime; virtual;
    procedure SetFECHA_FACTURAValue(const aValue: DateTime); virtual;
    function GetFECHA_FACTURAIsNull: Boolean; virtual;
    procedure SetFECHA_FACTURAIsNull(const aValue: Boolean); virtual;
    function GetSITUACIONValue: String; virtual;
    procedure SetSITUACIONValue(const aValue: String); virtual;
    function GetSITUACIONIsNull: Boolean; virtual;
    procedure SetSITUACIONIsNull(const aValue: Boolean); virtual;
    function GetBASE_IMPONIBLEValue: Currency; virtual;
    procedure SetBASE_IMPONIBLEValue(const aValue: Currency); virtual;
    function GetBASE_IMPONIBLEIsNull: Boolean; virtual;
    procedure SetBASE_IMPONIBLEIsNull(const aValue: Boolean); virtual;
    function GetDESCUENTOValue: Float; virtual;
    procedure SetDESCUENTOValue(const aValue: Float); virtual;
    function GetDESCUENTOIsNull: Boolean; virtual;
    procedure SetDESCUENTOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_DESCUENTOValue: Currency; virtual;
    procedure SetIMPORTE_DESCUENTOValue(const aValue: Currency); virtual;
    function GetIMPORTE_DESCUENTOIsNull: Boolean; virtual;
    procedure SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean); virtual;
    function GetIVAValue: Float; virtual;
    procedure SetIVAValue(const aValue: Float); virtual;
    function GetIVAIsNull: Boolean; virtual;
    procedure SetIVAIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_IVAValue: Currency; virtual;
    procedure SetIMPORTE_IVAValue(const aValue: Currency); virtual;
    function GetIMPORTE_IVAIsNull: Boolean; virtual;
    procedure SetIMPORTE_IVAIsNull(const aValue: Boolean); virtual;
    function GetREValue: Float; virtual;
    procedure SetREValue(const aValue: Float); virtual;
    function GetREIsNull: Boolean; virtual;
    procedure SetREIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_REValue: Currency; virtual;
    procedure SetIMPORTE_REValue(const aValue: Currency); virtual;
    function GetIMPORTE_REIsNull: Boolean; virtual;
    procedure SetIMPORTE_REIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALIsNull: Boolean; virtual;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean); virtual;
    function GetOBSERVACIONESValue: IROStrings; virtual;
    function GetOBSERVACIONESIsNull: Boolean; virtual;
    procedure SetOBSERVACIONESIsNull(const aValue: Boolean); virtual;
    function GetID_CLIENTEValue: Integer; virtual;
    procedure SetID_CLIENTEValue(const aValue: Integer); virtual;
    function GetID_CLIENTEIsNull: Boolean; virtual;
    procedure SetID_CLIENTEIsNull(const aValue: Boolean); virtual;
    function GetNOMBRE_CLIENTEValue: String; virtual;
    procedure SetNOMBRE_CLIENTEValue(const aValue: String); virtual;
    function GetNOMBRE_CLIENTEIsNull: Boolean; virtual;
    procedure SetNOMBRE_CLIENTEIsNull(const aValue: Boolean); virtual;
    function GetNOMBRE_COMERCIAL_CLIENTEValue: String; virtual;
    procedure SetNOMBRE_COMERCIAL_CLIENTEValue(const aValue: String); virtual;
    function GetNOMBRE_COMERCIAL_CLIENTEIsNull: Boolean; virtual;
    procedure SetNOMBRE_COMERCIAL_CLIENTEIsNull(const aValue: Boolean); virtual;
    function GetNIF_CIFValue: String; virtual;
    procedure SetNIF_CIFValue(const aValue: String); virtual;
    function GetNIF_CIFIsNull: Boolean; virtual;
    procedure SetNIF_CIFIsNull(const aValue: Boolean); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetNOMBREIsNull: Boolean; virtual;
    procedure SetNOMBREIsNull(const aValue: Boolean); virtual;
    function GetCALLEValue: String; virtual;
    procedure SetCALLEValue(const aValue: String); virtual;
    function GetCALLEIsNull: Boolean; virtual;
    procedure SetCALLEIsNull(const aValue: Boolean); virtual;
    function GetPOBLACIONValue: String; virtual;
    procedure SetPOBLACIONValue(const aValue: String); virtual;
    function GetPOBLACIONIsNull: Boolean; virtual;
    procedure SetPOBLACIONIsNull(const aValue: Boolean); virtual;
    function GetPROVINCIAValue: String; virtual;
    procedure SetPROVINCIAValue(const aValue: String); virtual;
    function GetPROVINCIAIsNull: Boolean; virtual;
    procedure SetPROVINCIAIsNull(const aValue: Boolean); virtual;
    function GetCODIGO_POSTALValue: String; virtual;
    procedure SetCODIGO_POSTALValue(const aValue: String); virtual;
    function GetCODIGO_POSTALIsNull: Boolean; virtual;
    procedure SetCODIGO_POSTALIsNull(const aValue: Boolean); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_ALTAIsNull: Boolean; virtual;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONIsNull: Boolean; virtual;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetUSUARIOIsNull: Boolean; virtual;
    procedure SetUSUARIOIsNull(const aValue: Boolean); virtual;
    function GetID_FORMA_PAGOValue: Integer; virtual;
    procedure SetID_FORMA_PAGOValue(const aValue: Integer); virtual;
    function GetID_FORMA_PAGOIsNull: Boolean; virtual;
    procedure SetID_FORMA_PAGOIsNull(const aValue: Boolean); virtual;
    function GetRECARGO_EQUIVALENCIAValue: SmallInt; virtual;
    procedure SetRECARGO_EQUIVALENCIAValue(const aValue: SmallInt); virtual;
    function GetRECARGO_EQUIVALENCIAIsNull: Boolean; virtual;
    procedure SetRECARGO_EQUIVALENCIAIsNull(const aValue: Boolean); virtual;
    function GetID_TIPO_IVAValue: Integer; virtual;
    procedure SetID_TIPO_IVAValue(const aValue: Integer); virtual;
    function GetID_TIPO_IVAIsNull: Boolean; virtual;
    procedure SetID_TIPO_IVAIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_NETOValue: Currency; virtual;
    procedure SetIMPORTE_NETOValue(const aValue: Currency); virtual;
    function GetIMPORTE_NETOIsNull: Boolean; virtual;
    procedure SetIMPORTE_NETOIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_PORTEValue: Currency; virtual;
    procedure SetIMPORTE_PORTEValue(const aValue: Currency); virtual;
    function GetIMPORTE_PORTEIsNull: Boolean; virtual;
    procedure SetIMPORTE_PORTEIsNull(const aValue: Boolean); virtual;
    function GetID_AGENTEValue: Integer; virtual;
    procedure SetID_AGENTEValue(const aValue: Integer); virtual;
    function GetID_AGENTEIsNull: Boolean; virtual;
    procedure SetID_AGENTEIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIA_COMISIONValue: String; virtual;
    procedure SetREFERENCIA_COMISIONValue(const aValue: String); virtual;
    function GetREFERENCIA_COMISIONIsNull: Boolean; virtual;
    procedure SetREFERENCIA_COMISIONIsNull(const aValue: Boolean); virtual;
    function GetIGNORAR_CONTABILIDADValue: SmallInt; virtual;
    procedure SetIGNORAR_CONTABILIDADValue(const aValue: SmallInt); virtual;
    function GetIGNORAR_CONTABILIDADIsNull: Boolean; virtual;
    procedure SetIGNORAR_CONTABILIDADIsNull(const aValue: Boolean); virtual;
    function GetID_TIENDAValue: Integer; virtual;
    procedure SetID_TIENDAValue(const aValue: Integer); virtual;
    function GetID_TIENDAIsNull: Boolean; virtual;
    procedure SetID_TIENDAIsNull(const aValue: Boolean); virtual;
    function GetTIENDAValue: String; virtual;
    procedure SetTIENDAValue(const aValue: String); virtual;
    function GetTIENDAIsNull: Boolean; virtual;
    procedure SetTIENDAIsNull(const aValue: Boolean); virtual;
    function GetID_SUBCUENTAValue: Integer; virtual;
    procedure SetID_SUBCUENTAValue(const aValue: Integer); virtual;
    function GetID_SUBCUENTAIsNull: Boolean; virtual;
    procedure SetID_SUBCUENTAIsNull(const aValue: Boolean); virtual;
    function GetSUBCUENTAValue: String; virtual;
    procedure SetSUBCUENTAValue(const aValue: String); virtual;
    function GetSUBCUENTAIsNull: Boolean; virtual;
    procedure SetSUBCUENTAIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property TIPO: String read GetTIPOValue write SetTIPOValue;
    property TIPOIsNull: Boolean read GetTIPOIsNull write SetTIPOIsNull;
    property ID_COMISION_LIQUIDADA: Integer read GetID_COMISION_LIQUIDADAValue write SetID_COMISION_LIQUIDADAValue;
    property ID_COMISION_LIQUIDADAIsNull: Boolean read GetID_COMISION_LIQUIDADAIsNull write SetID_COMISION_LIQUIDADAIsNull;
    property FECHA_FACTURA: DateTime read GetFECHA_FACTURAValue write SetFECHA_FACTURAValue;
    property FECHA_FACTURAIsNull: Boolean read GetFECHA_FACTURAIsNull write SetFECHA_FACTURAIsNull;
    property SITUACION: String read GetSITUACIONValue write SetSITUACIONValue;
    property SITUACIONIsNull: Boolean read GetSITUACIONIsNull write SetSITUACIONIsNull;
    property BASE_IMPONIBLE: Currency read GetBASE_IMPONIBLEValue write SetBASE_IMPONIBLEValue;
    property BASE_IMPONIBLEIsNull: Boolean read GetBASE_IMPONIBLEIsNull write SetBASE_IMPONIBLEIsNull;
    property DESCUENTO: Float read GetDESCUENTOValue write SetDESCUENTOValue;
    property DESCUENTOIsNull: Boolean read GetDESCUENTOIsNull write SetDESCUENTOIsNull;
    property IMPORTE_DESCUENTO: Currency read GetIMPORTE_DESCUENTOValue write SetIMPORTE_DESCUENTOValue;
    property IMPORTE_DESCUENTOIsNull: Boolean read GetIMPORTE_DESCUENTOIsNull write SetIMPORTE_DESCUENTOIsNull;
    property IVA: Float read GetIVAValue write SetIVAValue;
    property IVAIsNull: Boolean read GetIVAIsNull write SetIVAIsNull;
    property IMPORTE_IVA: Currency read GetIMPORTE_IVAValue write SetIMPORTE_IVAValue;
    property IMPORTE_IVAIsNull: Boolean read GetIMPORTE_IVAIsNull write SetIMPORTE_IVAIsNull;
    property RE: Float read GetREValue write SetREValue;
    property REIsNull: Boolean read GetREIsNull write SetREIsNull;
    property IMPORTE_RE: Currency read GetIMPORTE_REValue write SetIMPORTE_REValue;
    property IMPORTE_REIsNull: Boolean read GetIMPORTE_REIsNull write SetIMPORTE_REIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property OBSERVACIONES: IROStrings read GetOBSERVACIONESValue;
    property OBSERVACIONESIsNull: Boolean read GetOBSERVACIONESIsNull write SetOBSERVACIONESIsNull;
    property ID_CLIENTE: Integer read GetID_CLIENTEValue write SetID_CLIENTEValue;
    property ID_CLIENTEIsNull: Boolean read GetID_CLIENTEIsNull write SetID_CLIENTEIsNull;
    property NOMBRE_CLIENTE: String read GetNOMBRE_CLIENTEValue write SetNOMBRE_CLIENTEValue;
    property NOMBRE_CLIENTEIsNull: Boolean read GetNOMBRE_CLIENTEIsNull write SetNOMBRE_CLIENTEIsNull;
    property NOMBRE_COMERCIAL_CLIENTE: String read GetNOMBRE_COMERCIAL_CLIENTEValue write SetNOMBRE_COMERCIAL_CLIENTEValue;
    property NOMBRE_COMERCIAL_CLIENTEIsNull: Boolean read GetNOMBRE_COMERCIAL_CLIENTEIsNull write SetNOMBRE_COMERCIAL_CLIENTEIsNull;
    property NIF_CIF: String read GetNIF_CIFValue write SetNIF_CIFValue;
    property NIF_CIFIsNull: Boolean read GetNIF_CIFIsNull write SetNIF_CIFIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property CALLE: String read GetCALLEValue write SetCALLEValue;
    property CALLEIsNull: Boolean read GetCALLEIsNull write SetCALLEIsNull;
    property POBLACION: String read GetPOBLACIONValue write SetPOBLACIONValue;
    property POBLACIONIsNull: Boolean read GetPOBLACIONIsNull write SetPOBLACIONIsNull;
    property PROVINCIA: String read GetPROVINCIAValue write SetPROVINCIAValue;
    property PROVINCIAIsNull: Boolean read GetPROVINCIAIsNull write SetPROVINCIAIsNull;
    property CODIGO_POSTAL: String read GetCODIGO_POSTALValue write SetCODIGO_POSTALValue;
    property CODIGO_POSTALIsNull: Boolean read GetCODIGO_POSTALIsNull write SetCODIGO_POSTALIsNull;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull: Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull: Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
    property ID_FORMA_PAGO: Integer read GetID_FORMA_PAGOValue write SetID_FORMA_PAGOValue;
    property ID_FORMA_PAGOIsNull: Boolean read GetID_FORMA_PAGOIsNull write SetID_FORMA_PAGOIsNull;
    property RECARGO_EQUIVALENCIA: SmallInt read GetRECARGO_EQUIVALENCIAValue write SetRECARGO_EQUIVALENCIAValue;
    property RECARGO_EQUIVALENCIAIsNull: Boolean read GetRECARGO_EQUIVALENCIAIsNull write SetRECARGO_EQUIVALENCIAIsNull;
    property ID_TIPO_IVA: Integer read GetID_TIPO_IVAValue write SetID_TIPO_IVAValue;
    property ID_TIPO_IVAIsNull: Boolean read GetID_TIPO_IVAIsNull write SetID_TIPO_IVAIsNull;
    property IMPORTE_NETO: Currency read GetIMPORTE_NETOValue write SetIMPORTE_NETOValue;
    property IMPORTE_NETOIsNull: Boolean read GetIMPORTE_NETOIsNull write SetIMPORTE_NETOIsNull;
    property IMPORTE_PORTE: Currency read GetIMPORTE_PORTEValue write SetIMPORTE_PORTEValue;
    property IMPORTE_PORTEIsNull: Boolean read GetIMPORTE_PORTEIsNull write SetIMPORTE_PORTEIsNull;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property ID_AGENTEIsNull: Boolean read GetID_AGENTEIsNull write SetID_AGENTEIsNull;
    property REFERENCIA_COMISION: String read GetREFERENCIA_COMISIONValue write SetREFERENCIA_COMISIONValue;
    property REFERENCIA_COMISIONIsNull: Boolean read GetREFERENCIA_COMISIONIsNull write SetREFERENCIA_COMISIONIsNull;
    property IGNORAR_CONTABILIDAD: SmallInt read GetIGNORAR_CONTABILIDADValue write SetIGNORAR_CONTABILIDADValue;
    property IGNORAR_CONTABILIDADIsNull: Boolean read GetIGNORAR_CONTABILIDADIsNull write SetIGNORAR_CONTABILIDADIsNull;
    property ID_TIENDA: Integer read GetID_TIENDAValue write SetID_TIENDAValue;
    property ID_TIENDAIsNull: Boolean read GetID_TIENDAIsNull write SetID_TIENDAIsNull;
    property TIENDA: String read GetTIENDAValue write SetTIENDAValue;
    property TIENDAIsNull: Boolean read GetTIENDAIsNull write SetTIENDAIsNull;
    property ID_SUBCUENTA: Integer read GetID_SUBCUENTAValue write SetID_SUBCUENTAValue;
    property ID_SUBCUENTAIsNull: Boolean read GetID_SUBCUENTAIsNull write SetID_SUBCUENTAIsNull;
    property SUBCUENTA: String read GetSUBCUENTAValue write SetSUBCUENTAValue;
    property SUBCUENTAIsNull: Boolean read GetSUBCUENTAIsNull write SetSUBCUENTAIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IVendedores_Comision }
  IVendedores_Comision = interface(IDAStronglyTypedDataTable)
  ['{B4E71678-F0BA-4633-8BB8-5F68EE690CE5}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetID_COMISIONValue: Integer;
    procedure SetID_COMISIONValue(const aValue: Integer);
    function GetID_COMISIONIsNull: Boolean;
    procedure SetID_COMISIONIsNull(const aValue: Boolean);
    function GetID_VENDEDORValue: Integer;
    procedure SetID_VENDEDORValue(const aValue: Integer);
    function GetID_VENDEDORIsNull: Boolean;
    procedure SetID_VENDEDORIsNull(const aValue: Boolean);
    function GetNOMBREValue: String;
    procedure SetNOMBREValue(const aValue: String);
    function GetNOMBREIsNull: Boolean;
    procedure SetNOMBREIsNull(const aValue: Boolean);
    function GetCOMISIONValue: Float;
    procedure SetCOMISIONValue(const aValue: Float);
    function GetCOMISIONIsNull: Boolean;
    procedure SetCOMISIONIsNull(const aValue: Boolean);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetIMPORTE_TOTALIsNull: Boolean;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_COMISION: Integer read GetID_COMISIONValue write SetID_COMISIONValue;
    property ID_COMISIONIsNull: Boolean read GetID_COMISIONIsNull write SetID_COMISIONIsNull;
    property ID_VENDEDOR: Integer read GetID_VENDEDORValue write SetID_VENDEDORValue;
    property ID_VENDEDORIsNull: Boolean read GetID_VENDEDORIsNull write SetID_VENDEDORIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property COMISION: Float read GetCOMISIONValue write SetCOMISIONValue;
    property COMISIONIsNull: Boolean read GetCOMISIONIsNull write SetCOMISIONIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
  end;

  { TVendedores_ComisionDataTableRules }
  TVendedores_ComisionDataTableRules = class(TIntfObjectDADataTableRules, IVendedores_Comision)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_COMISIONValue: Integer; virtual;
    procedure SetID_COMISIONValue(const aValue: Integer); virtual;
    function GetID_COMISIONIsNull: Boolean; virtual;
    procedure SetID_COMISIONIsNull(const aValue: Boolean); virtual;
    function GetID_VENDEDORValue: Integer; virtual;
    procedure SetID_VENDEDORValue(const aValue: Integer); virtual;
    function GetID_VENDEDORIsNull: Boolean; virtual;
    procedure SetID_VENDEDORIsNull(const aValue: Boolean); virtual;
    function GetNOMBREValue: String; virtual;
    procedure SetNOMBREValue(const aValue: String); virtual;
    function GetNOMBREIsNull: Boolean; virtual;
    procedure SetNOMBREIsNull(const aValue: Boolean); virtual;
    function GetCOMISIONValue: Float; virtual;
    procedure SetCOMISIONValue(const aValue: Float); virtual;
    function GetCOMISIONIsNull: Boolean; virtual;
    procedure SetCOMISIONIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALIsNull: Boolean; virtual;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_COMISION: Integer read GetID_COMISIONValue write SetID_COMISIONValue;
    property ID_COMISIONIsNull: Boolean read GetID_COMISIONIsNull write SetID_COMISIONIsNull;
    property ID_VENDEDOR: Integer read GetID_VENDEDORValue write SetID_VENDEDORValue;
    property ID_VENDEDORIsNull: Boolean read GetID_VENDEDORIsNull write SetID_VENDEDORIsNull;
    property NOMBRE: String read GetNOMBREValue write SetNOMBREValue;
    property NOMBREIsNull: Boolean read GetNOMBREIsNull write SetNOMBREIsNull;
    property COMISION: Float read GetCOMISIONValue write SetCOMISIONValue;
    property COMISIONIsNull: Boolean read GetCOMISIONIsNull write SetCOMISIONIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

  { IComisiones }
  IComisiones = interface(IDAStronglyTypedDataTable)
  ['{32ADC59A-A0CA-4CC5-B987-EEC90899CD9A}']
    { Property getters and setters }
    function GetIDValue: Integer;
    procedure SetIDValue(const aValue: Integer);
    function GetIDIsNull: Boolean;
    procedure SetIDIsNull(const aValue: Boolean);
    function GetID_EMPRESAValue: Integer;
    procedure SetID_EMPRESAValue(const aValue: Integer);
    function GetID_EMPRESAIsNull: Boolean;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean);
    function GetREFERENCIAValue: String;
    procedure SetREFERENCIAValue(const aValue: String);
    function GetREFERENCIAIsNull: Boolean;
    procedure SetREFERENCIAIsNull(const aValue: Boolean);
    function GetID_AGENTEValue: Integer;
    procedure SetID_AGENTEValue(const aValue: Integer);
    function GetID_AGENTEIsNull: Boolean;
    procedure SetID_AGENTEIsNull(const aValue: Boolean);
    function GetDESCRIPCIONValue: String;
    procedure SetDESCRIPCIONValue(const aValue: String);
    function GetDESCRIPCIONIsNull: Boolean;
    procedure SetDESCRIPCIONIsNull(const aValue: Boolean);
    function GetFECHAValue: DateTime;
    procedure SetFECHAValue(const aValue: DateTime);
    function GetFECHAIsNull: Boolean;
    procedure SetFECHAIsNull(const aValue: Boolean);
    function GetIMPORTE_TOTALValue: Currency;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency);
    function GetIMPORTE_TOTALIsNull: Boolean;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean);
    function GetFECHA_ALTAValue: DateTime;
    procedure SetFECHA_ALTAValue(const aValue: DateTime);
    function GetFECHA_ALTAIsNull: Boolean;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean);
    function GetFECHA_MODIFICACIONValue: DateTime;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime);
    function GetFECHA_MODIFICACIONIsNull: Boolean;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
    function GetUSUARIOValue: String;
    procedure SetUSUARIOValue(const aValue: String);
    function GetUSUARIOIsNull: Boolean;
    procedure SetUSUARIOIsNull(const aValue: Boolean);


    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property ID_AGENTEIsNull: Boolean read GetID_AGENTEIsNull write SetID_AGENTEIsNull;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property DESCRIPCIONIsNull: Boolean read GetDESCRIPCIONIsNull write SetDESCRIPCIONIsNull;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull: Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull: Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull: Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;
  end;

  { TComisionesDataTableRules }
  TComisionesDataTableRules = class(TIntfObjectDADataTableRules, IComisiones)
  private
  protected
    { Property getters and setters }
    function GetIDValue: Integer; virtual;
    procedure SetIDValue(const aValue: Integer); virtual;
    function GetIDIsNull: Boolean; virtual;
    procedure SetIDIsNull(const aValue: Boolean); virtual;
    function GetID_EMPRESAValue: Integer; virtual;
    procedure SetID_EMPRESAValue(const aValue: Integer); virtual;
    function GetID_EMPRESAIsNull: Boolean; virtual;
    procedure SetID_EMPRESAIsNull(const aValue: Boolean); virtual;
    function GetREFERENCIAValue: String; virtual;
    procedure SetREFERENCIAValue(const aValue: String); virtual;
    function GetREFERENCIAIsNull: Boolean; virtual;
    procedure SetREFERENCIAIsNull(const aValue: Boolean); virtual;
    function GetID_AGENTEValue: Integer; virtual;
    procedure SetID_AGENTEValue(const aValue: Integer); virtual;
    function GetID_AGENTEIsNull: Boolean; virtual;
    procedure SetID_AGENTEIsNull(const aValue: Boolean); virtual;
    function GetDESCRIPCIONValue: String; virtual;
    procedure SetDESCRIPCIONValue(const aValue: String); virtual;
    function GetDESCRIPCIONIsNull: Boolean; virtual;
    procedure SetDESCRIPCIONIsNull(const aValue: Boolean); virtual;
    function GetFECHAValue: DateTime; virtual;
    procedure SetFECHAValue(const aValue: DateTime); virtual;
    function GetFECHAIsNull: Boolean; virtual;
    procedure SetFECHAIsNull(const aValue: Boolean); virtual;
    function GetIMPORTE_TOTALValue: Currency; virtual;
    procedure SetIMPORTE_TOTALValue(const aValue: Currency); virtual;
    function GetIMPORTE_TOTALIsNull: Boolean; virtual;
    procedure SetIMPORTE_TOTALIsNull(const aValue: Boolean); virtual;
    function GetFECHA_ALTAValue: DateTime; virtual;
    procedure SetFECHA_ALTAValue(const aValue: DateTime); virtual;
    function GetFECHA_ALTAIsNull: Boolean; virtual;
    procedure SetFECHA_ALTAIsNull(const aValue: Boolean); virtual;
    function GetFECHA_MODIFICACIONValue: DateTime; virtual;
    procedure SetFECHA_MODIFICACIONValue(const aValue: DateTime); virtual;
    function GetFECHA_MODIFICACIONIsNull: Boolean; virtual;
    procedure SetFECHA_MODIFICACIONIsNull(const aValue: Boolean); virtual;
    function GetUSUARIOValue: String; virtual;
    procedure SetUSUARIOValue(const aValue: String); virtual;
    function GetUSUARIOIsNull: Boolean; virtual;
    procedure SetUSUARIOIsNull(const aValue: Boolean); virtual;

    { Properties }
    property ID: Integer read GetIDValue write SetIDValue;
    property IDIsNull: Boolean read GetIDIsNull write SetIDIsNull;
    property ID_EMPRESA: Integer read GetID_EMPRESAValue write SetID_EMPRESAValue;
    property ID_EMPRESAIsNull: Boolean read GetID_EMPRESAIsNull write SetID_EMPRESAIsNull;
    property REFERENCIA: String read GetREFERENCIAValue write SetREFERENCIAValue;
    property REFERENCIAIsNull: Boolean read GetREFERENCIAIsNull write SetREFERENCIAIsNull;
    property ID_AGENTE: Integer read GetID_AGENTEValue write SetID_AGENTEValue;
    property ID_AGENTEIsNull: Boolean read GetID_AGENTEIsNull write SetID_AGENTEIsNull;
    property DESCRIPCION: String read GetDESCRIPCIONValue write SetDESCRIPCIONValue;
    property DESCRIPCIONIsNull: Boolean read GetDESCRIPCIONIsNull write SetDESCRIPCIONIsNull;
    property FECHA: DateTime read GetFECHAValue write SetFECHAValue;
    property FECHAIsNull: Boolean read GetFECHAIsNull write SetFECHAIsNull;
    property IMPORTE_TOTAL: Currency read GetIMPORTE_TOTALValue write SetIMPORTE_TOTALValue;
    property IMPORTE_TOTALIsNull: Boolean read GetIMPORTE_TOTALIsNull write SetIMPORTE_TOTALIsNull;
    property FECHA_ALTA: DateTime read GetFECHA_ALTAValue write SetFECHA_ALTAValue;
    property FECHA_ALTAIsNull: Boolean read GetFECHA_ALTAIsNull write SetFECHA_ALTAIsNull;
    property FECHA_MODIFICACION: DateTime read GetFECHA_MODIFICACIONValue write SetFECHA_MODIFICACIONValue;
    property FECHA_MODIFICACIONIsNull: Boolean read GetFECHA_MODIFICACIONIsNull write SetFECHA_MODIFICACIONIsNull;
    property USUARIO: String read GetUSUARIOValue write SetUSUARIOValue;
    property USUARIOIsNull: Boolean read GetUSUARIOIsNull write SetUSUARIOIsNull;

  public
    constructor Create(aDataTable: TDADataTable); override;
    destructor Destroy; override;

  end;

implementation

uses Variants, uROBinaryHelpers;

{ TFacturas_ComisionDataTableRules }
constructor TFacturas_ComisionDataTableRules.Create(aDataTable: TDADataTable);
var
  StrList: TStringList;
begin
  inherited;

  StrList := TStringList.Create;
  StrList.OnChange := OBSERVACIONES_OnChange;
  f_OBSERVACIONES := NewROStrings(StrList,True);
end;

destructor TFacturas_ComisionDataTableRules.Destroy;
begin
  inherited;
end;

procedure TFacturas_ComisionDataTableRules.OBSERVACIONES_OnChange(Sender: TObject);
begin
  if DataTable.Editing then DataTable.Fields[idx_Facturas_ComisionOBSERVACIONES].AsVariant := TStringList(Sender).Text;
end;

function TFacturas_ComisionDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_EMPRESA].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_EMPRESA].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_EMPRESAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_EMPRESA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID_EMPRESA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionREFERENCIA].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionREFERENCIA].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionREFERENCIA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionREFERENCIA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetTIPOValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionTIPO].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetTIPOValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionTIPO].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetTIPOIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionTIPO].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetTIPOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionTIPO].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetID_COMISION_LIQUIDADAValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_COMISION_LIQUIDADA].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_COMISION_LIQUIDADAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_COMISION_LIQUIDADA].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_COMISION_LIQUIDADAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_COMISION_LIQUIDADA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetID_COMISION_LIQUIDADAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID_COMISION_LIQUIDADA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetFECHA_FACTURAValue: DateTime;
begin
  result := DataTable.Fields[idx_Facturas_ComisionFECHA_FACTURA].AsDateTime;
end;

procedure TFacturas_ComisionDataTableRules.SetFECHA_FACTURAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_Facturas_ComisionFECHA_FACTURA].AsDateTime := aValue;
end;

function TFacturas_ComisionDataTableRules.GetFECHA_FACTURAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionFECHA_FACTURA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetFECHA_FACTURAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionFECHA_FACTURA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetSITUACIONValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionSITUACION].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetSITUACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionSITUACION].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetSITUACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionSITUACION].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetSITUACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionSITUACION].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetBASE_IMPONIBLEValue: Currency;
begin
  result := DataTable.Fields[idx_Facturas_ComisionBASE_IMPONIBLE].AsCurrency;
end;

procedure TFacturas_ComisionDataTableRules.SetBASE_IMPONIBLEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_Facturas_ComisionBASE_IMPONIBLE].AsCurrency := aValue;
end;

function TFacturas_ComisionDataTableRules.GetBASE_IMPONIBLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionBASE_IMPONIBLE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetBASE_IMPONIBLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionBASE_IMPONIBLE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetDESCUENTOValue: Float;
begin
  result := DataTable.Fields[idx_Facturas_ComisionDESCUENTO].AsFloat;
end;

procedure TFacturas_ComisionDataTableRules.SetDESCUENTOValue(const aValue: Float);
begin
  DataTable.Fields[idx_Facturas_ComisionDESCUENTO].AsFloat := aValue;
end;

function TFacturas_ComisionDataTableRules.GetDESCUENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionDESCUENTO].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetDESCUENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionDESCUENTO].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_DESCUENTOValue: Currency;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_DESCUENTO].AsCurrency;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_DESCUENTOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_Facturas_ComisionIMPORTE_DESCUENTO].AsCurrency := aValue;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_DESCUENTOIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_DESCUENTO].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_DESCUENTOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionIMPORTE_DESCUENTO].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetIVAValue: Float;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIVA].AsFloat;
end;

procedure TFacturas_ComisionDataTableRules.SetIVAValue(const aValue: Float);
begin
  DataTable.Fields[idx_Facturas_ComisionIVA].AsFloat := aValue;
end;

function TFacturas_ComisionDataTableRules.GetIVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIVA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetIVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionIVA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_IVAValue: Currency;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_IVA].AsCurrency;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_IVAValue(const aValue: Currency);
begin
  DataTable.Fields[idx_Facturas_ComisionIMPORTE_IVA].AsCurrency := aValue;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_IVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_IVA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_IVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionIMPORTE_IVA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetREValue: Float;
begin
  result := DataTable.Fields[idx_Facturas_ComisionRE].AsFloat;
end;

procedure TFacturas_ComisionDataTableRules.SetREValue(const aValue: Float);
begin
  DataTable.Fields[idx_Facturas_ComisionRE].AsFloat := aValue;
end;

function TFacturas_ComisionDataTableRules.GetREIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionRE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetREIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionRE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_REValue: Currency;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_RE].AsCurrency;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_REValue(const aValue: Currency);
begin
  DataTable.Fields[idx_Facturas_ComisionIMPORTE_RE].AsCurrency := aValue;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_REIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_RE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_REIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionIMPORTE_RE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_TOTAL].AsCurrency;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_Facturas_ComisionIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_TOTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_TOTAL].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_TOTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionIMPORTE_TOTAL].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetOBSERVACIONESValue: IROStrings;
begin
  result := f_OBSERVACIONES;
  result.Text := DataTable.Fields[idx_Facturas_ComisionOBSERVACIONES].AsString;
end;

function TFacturas_ComisionDataTableRules.GetOBSERVACIONESIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionOBSERVACIONES].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetOBSERVACIONESIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionOBSERVACIONES].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetID_CLIENTEValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_CLIENTE].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_CLIENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_CLIENTE].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_CLIENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_CLIENTE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetID_CLIENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID_CLIENTE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetNOMBRE_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionNOMBRE_CLIENTE].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetNOMBRE_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionNOMBRE_CLIENTE].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetNOMBRE_CLIENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionNOMBRE_CLIENTE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetNOMBRE_CLIENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionNOMBRE_CLIENTE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetNOMBRE_COMERCIAL_CLIENTEValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionNOMBRE_COMERCIAL_CLIENTE].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetNOMBRE_COMERCIAL_CLIENTEValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionNOMBRE_COMERCIAL_CLIENTE].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetNOMBRE_COMERCIAL_CLIENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionNOMBRE_COMERCIAL_CLIENTE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetNOMBRE_COMERCIAL_CLIENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionNOMBRE_COMERCIAL_CLIENTE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetNIF_CIFValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionNIF_CIF].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetNIF_CIFValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionNIF_CIF].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetNIF_CIFIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionNIF_CIF].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetNIF_CIFIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionNIF_CIF].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionNOMBRE].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionNOMBRE].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetNOMBREIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionNOMBRE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetNOMBREIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionNOMBRE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetCALLEValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionCALLE].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetCALLEValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionCALLE].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetCALLEIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionCALLE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetCALLEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionCALLE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetPOBLACIONValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionPOBLACION].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetPOBLACIONValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionPOBLACION].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetPOBLACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionPOBLACION].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetPOBLACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionPOBLACION].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetPROVINCIAValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionPROVINCIA].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetPROVINCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionPROVINCIA].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetPROVINCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionPROVINCIA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetPROVINCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionPROVINCIA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetCODIGO_POSTALValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionCODIGO_POSTAL].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetCODIGO_POSTALValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionCODIGO_POSTAL].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetCODIGO_POSTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionCODIGO_POSTAL].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetCODIGO_POSTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionCODIGO_POSTAL].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_Facturas_ComisionFECHA_ALTA].AsDateTime;
end;

procedure TFacturas_ComisionDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_Facturas_ComisionFECHA_ALTA].AsDateTime := aValue;
end;

function TFacturas_ComisionDataTableRules.GetFECHA_ALTAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionFECHA_ALTA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetFECHA_ALTAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionFECHA_ALTA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_Facturas_ComisionFECHA_MODIFICACION].AsDateTime;
end;

procedure TFacturas_ComisionDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_Facturas_ComisionFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TFacturas_ComisionDataTableRules.GetFECHA_MODIFICACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionFECHA_MODIFICACION].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionFECHA_MODIFICACION].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionUSUARIO].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionUSUARIO].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetUSUARIOIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionUSUARIO].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetUSUARIOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionUSUARIO].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetID_FORMA_PAGOValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_FORMA_PAGO].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_FORMA_PAGOValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_FORMA_PAGO].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_FORMA_PAGOIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_FORMA_PAGO].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetID_FORMA_PAGOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID_FORMA_PAGO].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetRECARGO_EQUIVALENCIAValue: SmallInt;
begin
  result := DataTable.Fields[idx_Facturas_ComisionRECARGO_EQUIVALENCIA].AsSmallInt;
end;

procedure TFacturas_ComisionDataTableRules.SetRECARGO_EQUIVALENCIAValue(const aValue: SmallInt);
begin
  DataTable.Fields[idx_Facturas_ComisionRECARGO_EQUIVALENCIA].AsSmallInt := aValue;
end;

function TFacturas_ComisionDataTableRules.GetRECARGO_EQUIVALENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionRECARGO_EQUIVALENCIA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetRECARGO_EQUIVALENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionRECARGO_EQUIVALENCIA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetID_TIPO_IVAValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_TIPO_IVA].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_TIPO_IVAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_TIPO_IVA].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_TIPO_IVAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_TIPO_IVA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetID_TIPO_IVAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID_TIPO_IVA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_NETOValue: Currency;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_NETO].AsCurrency;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_NETOValue(const aValue: Currency);
begin
  DataTable.Fields[idx_Facturas_ComisionIMPORTE_NETO].AsCurrency := aValue;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_NETOIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_NETO].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_NETOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionIMPORTE_NETO].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_PORTEValue: Currency;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_PORTE].AsCurrency;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_PORTEValue(const aValue: Currency);
begin
  DataTable.Fields[idx_Facturas_ComisionIMPORTE_PORTE].AsCurrency := aValue;
end;

function TFacturas_ComisionDataTableRules.GetIMPORTE_PORTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIMPORTE_PORTE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetIMPORTE_PORTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionIMPORTE_PORTE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetID_AGENTEValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_AGENTE].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_AGENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_AGENTE].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_AGENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_AGENTE].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetID_AGENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID_AGENTE].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetREFERENCIA_COMISIONValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionREFERENCIA_COMISION].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetREFERENCIA_COMISIONValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionREFERENCIA_COMISION].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetREFERENCIA_COMISIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionREFERENCIA_COMISION].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetREFERENCIA_COMISIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionREFERENCIA_COMISION].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetIGNORAR_CONTABILIDADValue: SmallInt;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIGNORAR_CONTABILIDAD].AsSmallInt;
end;

procedure TFacturas_ComisionDataTableRules.SetIGNORAR_CONTABILIDADValue(const aValue: SmallInt);
begin
  DataTable.Fields[idx_Facturas_ComisionIGNORAR_CONTABILIDAD].AsSmallInt := aValue;
end;

function TFacturas_ComisionDataTableRules.GetIGNORAR_CONTABILIDADIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionIGNORAR_CONTABILIDAD].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetIGNORAR_CONTABILIDADIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionIGNORAR_CONTABILIDAD].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetID_TIENDAValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_TIENDA].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_TIENDAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_TIENDA].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_TIENDAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_TIENDA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetID_TIENDAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID_TIENDA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetTIENDAValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionTIENDA].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetTIENDAValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionTIENDA].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetTIENDAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionTIENDA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetTIENDAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionTIENDA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetID_SUBCUENTAValue: Integer;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_SUBCUENTA].AsInteger;
end;

procedure TFacturas_ComisionDataTableRules.SetID_SUBCUENTAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Facturas_ComisionID_SUBCUENTA].AsInteger := aValue;
end;

function TFacturas_ComisionDataTableRules.GetID_SUBCUENTAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionID_SUBCUENTA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetID_SUBCUENTAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionID_SUBCUENTA].AsVariant := Null;
end;

function TFacturas_ComisionDataTableRules.GetSUBCUENTAValue: String;
begin
  result := DataTable.Fields[idx_Facturas_ComisionSUBCUENTA].AsString;
end;

procedure TFacturas_ComisionDataTableRules.SetSUBCUENTAValue(const aValue: String);
begin
  DataTable.Fields[idx_Facturas_ComisionSUBCUENTA].AsString := aValue;
end;

function TFacturas_ComisionDataTableRules.GetSUBCUENTAIsNull: boolean;
begin
  result := DataTable.Fields[idx_Facturas_ComisionSUBCUENTA].IsNull;
end;

procedure TFacturas_ComisionDataTableRules.SetSUBCUENTAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Facturas_ComisionSUBCUENTA].AsVariant := Null;
end;


{ TVendedores_ComisionDataTableRules }
constructor TVendedores_ComisionDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TVendedores_ComisionDataTableRules.Destroy;
begin
  inherited;
end;

function TVendedores_ComisionDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_Vendedores_ComisionID].AsInteger;
end;

procedure TVendedores_ComisionDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Vendedores_ComisionID].AsInteger := aValue;
end;

function TVendedores_ComisionDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_Vendedores_ComisionID].IsNull;
end;

procedure TVendedores_ComisionDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Vendedores_ComisionID].AsVariant := Null;
end;

function TVendedores_ComisionDataTableRules.GetID_COMISIONValue: Integer;
begin
  result := DataTable.Fields[idx_Vendedores_ComisionID_COMISION].AsInteger;
end;

procedure TVendedores_ComisionDataTableRules.SetID_COMISIONValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Vendedores_ComisionID_COMISION].AsInteger := aValue;
end;

function TVendedores_ComisionDataTableRules.GetID_COMISIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_Vendedores_ComisionID_COMISION].IsNull;
end;

procedure TVendedores_ComisionDataTableRules.SetID_COMISIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Vendedores_ComisionID_COMISION].AsVariant := Null;
end;

function TVendedores_ComisionDataTableRules.GetID_VENDEDORValue: Integer;
begin
  result := DataTable.Fields[idx_Vendedores_ComisionID_VENDEDOR].AsInteger;
end;

procedure TVendedores_ComisionDataTableRules.SetID_VENDEDORValue(const aValue: Integer);
begin
  DataTable.Fields[idx_Vendedores_ComisionID_VENDEDOR].AsInteger := aValue;
end;

function TVendedores_ComisionDataTableRules.GetID_VENDEDORIsNull: boolean;
begin
  result := DataTable.Fields[idx_Vendedores_ComisionID_VENDEDOR].IsNull;
end;

procedure TVendedores_ComisionDataTableRules.SetID_VENDEDORIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Vendedores_ComisionID_VENDEDOR].AsVariant := Null;
end;

function TVendedores_ComisionDataTableRules.GetNOMBREValue: String;
begin
  result := DataTable.Fields[idx_Vendedores_ComisionNOMBRE].AsString;
end;

procedure TVendedores_ComisionDataTableRules.SetNOMBREValue(const aValue: String);
begin
  DataTable.Fields[idx_Vendedores_ComisionNOMBRE].AsString := aValue;
end;

function TVendedores_ComisionDataTableRules.GetNOMBREIsNull: boolean;
begin
  result := DataTable.Fields[idx_Vendedores_ComisionNOMBRE].IsNull;
end;

procedure TVendedores_ComisionDataTableRules.SetNOMBREIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Vendedores_ComisionNOMBRE].AsVariant := Null;
end;

function TVendedores_ComisionDataTableRules.GetCOMISIONValue: Float;
begin
  result := DataTable.Fields[idx_Vendedores_ComisionCOMISION].AsFloat;
end;

procedure TVendedores_ComisionDataTableRules.SetCOMISIONValue(const aValue: Float);
begin
  DataTable.Fields[idx_Vendedores_ComisionCOMISION].AsFloat := aValue;
end;

function TVendedores_ComisionDataTableRules.GetCOMISIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_Vendedores_ComisionCOMISION].IsNull;
end;

procedure TVendedores_ComisionDataTableRules.SetCOMISIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Vendedores_ComisionCOMISION].AsVariant := Null;
end;

function TVendedores_ComisionDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_Vendedores_ComisionIMPORTE_TOTAL].AsCurrency;
end;

procedure TVendedores_ComisionDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_Vendedores_ComisionIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TVendedores_ComisionDataTableRules.GetIMPORTE_TOTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_Vendedores_ComisionIMPORTE_TOTAL].IsNull;
end;

procedure TVendedores_ComisionDataTableRules.SetIMPORTE_TOTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_Vendedores_ComisionIMPORTE_TOTAL].AsVariant := Null;
end;


{ TComisionesDataTableRules }
constructor TComisionesDataTableRules.Create(aDataTable: TDADataTable);
begin
  inherited;
end;

destructor TComisionesDataTableRules.Destroy;
begin
  inherited;
end;

function TComisionesDataTableRules.GetIDValue: Integer;
begin
  result := DataTable.Fields[idx_ComisionesID].AsInteger;
end;

procedure TComisionesDataTableRules.SetIDValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ComisionesID].AsInteger := aValue;
end;

function TComisionesDataTableRules.GetIDIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesID].IsNull;
end;

procedure TComisionesDataTableRules.SetIDIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesID].AsVariant := Null;
end;

function TComisionesDataTableRules.GetID_EMPRESAValue: Integer;
begin
  result := DataTable.Fields[idx_ComisionesID_EMPRESA].AsInteger;
end;

procedure TComisionesDataTableRules.SetID_EMPRESAValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ComisionesID_EMPRESA].AsInteger := aValue;
end;

function TComisionesDataTableRules.GetID_EMPRESAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesID_EMPRESA].IsNull;
end;

procedure TComisionesDataTableRules.SetID_EMPRESAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesID_EMPRESA].AsVariant := Null;
end;

function TComisionesDataTableRules.GetREFERENCIAValue: String;
begin
  result := DataTable.Fields[idx_ComisionesREFERENCIA].AsString;
end;

procedure TComisionesDataTableRules.SetREFERENCIAValue(const aValue: String);
begin
  DataTable.Fields[idx_ComisionesREFERENCIA].AsString := aValue;
end;

function TComisionesDataTableRules.GetREFERENCIAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesREFERENCIA].IsNull;
end;

procedure TComisionesDataTableRules.SetREFERENCIAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesREFERENCIA].AsVariant := Null;
end;

function TComisionesDataTableRules.GetID_AGENTEValue: Integer;
begin
  result := DataTable.Fields[idx_ComisionesID_AGENTE].AsInteger;
end;

procedure TComisionesDataTableRules.SetID_AGENTEValue(const aValue: Integer);
begin
  DataTable.Fields[idx_ComisionesID_AGENTE].AsInteger := aValue;
end;

function TComisionesDataTableRules.GetID_AGENTEIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesID_AGENTE].IsNull;
end;

procedure TComisionesDataTableRules.SetID_AGENTEIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesID_AGENTE].AsVariant := Null;
end;

function TComisionesDataTableRules.GetDESCRIPCIONValue: String;
begin
  result := DataTable.Fields[idx_ComisionesDESCRIPCION].AsString;
end;

procedure TComisionesDataTableRules.SetDESCRIPCIONValue(const aValue: String);
begin
  DataTable.Fields[idx_ComisionesDESCRIPCION].AsString := aValue;
end;

function TComisionesDataTableRules.GetDESCRIPCIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesDESCRIPCION].IsNull;
end;

procedure TComisionesDataTableRules.SetDESCRIPCIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesDESCRIPCION].AsVariant := Null;
end;

function TComisionesDataTableRules.GetFECHAValue: DateTime;
begin
  result := DataTable.Fields[idx_ComisionesFECHA].AsDateTime;
end;

procedure TComisionesDataTableRules.SetFECHAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_ComisionesFECHA].AsDateTime := aValue;
end;

function TComisionesDataTableRules.GetFECHAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesFECHA].IsNull;
end;

procedure TComisionesDataTableRules.SetFECHAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesFECHA].AsVariant := Null;
end;

function TComisionesDataTableRules.GetIMPORTE_TOTALValue: Currency;
begin
  result := DataTable.Fields[idx_ComisionesIMPORTE_TOTAL].AsCurrency;
end;

procedure TComisionesDataTableRules.SetIMPORTE_TOTALValue(const aValue: Currency);
begin
  DataTable.Fields[idx_ComisionesIMPORTE_TOTAL].AsCurrency := aValue;
end;

function TComisionesDataTableRules.GetIMPORTE_TOTALIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesIMPORTE_TOTAL].IsNull;
end;

procedure TComisionesDataTableRules.SetIMPORTE_TOTALIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesIMPORTE_TOTAL].AsVariant := Null;
end;

function TComisionesDataTableRules.GetFECHA_ALTAValue: DateTime;
begin
  result := DataTable.Fields[idx_ComisionesFECHA_ALTA].AsDateTime;
end;

procedure TComisionesDataTableRules.SetFECHA_ALTAValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_ComisionesFECHA_ALTA].AsDateTime := aValue;
end;

function TComisionesDataTableRules.GetFECHA_ALTAIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesFECHA_ALTA].IsNull;
end;

procedure TComisionesDataTableRules.SetFECHA_ALTAIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesFECHA_ALTA].AsVariant := Null;
end;

function TComisionesDataTableRules.GetFECHA_MODIFICACIONValue: DateTime;
begin
  result := DataTable.Fields[idx_ComisionesFECHA_MODIFICACION].AsDateTime;
end;

procedure TComisionesDataTableRules.SetFECHA_MODIFICACIONValue(const aValue: DateTime);
begin
  DataTable.Fields[idx_ComisionesFECHA_MODIFICACION].AsDateTime := aValue;
end;

function TComisionesDataTableRules.GetFECHA_MODIFICACIONIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesFECHA_MODIFICACION].IsNull;
end;

procedure TComisionesDataTableRules.SetFECHA_MODIFICACIONIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesFECHA_MODIFICACION].AsVariant := Null;
end;

function TComisionesDataTableRules.GetUSUARIOValue: String;
begin
  result := DataTable.Fields[idx_ComisionesUSUARIO].AsString;
end;

procedure TComisionesDataTableRules.SetUSUARIOValue(const aValue: String);
begin
  DataTable.Fields[idx_ComisionesUSUARIO].AsString := aValue;
end;

function TComisionesDataTableRules.GetUSUARIOIsNull: boolean;
begin
  result := DataTable.Fields[idx_ComisionesUSUARIO].IsNull;
end;

procedure TComisionesDataTableRules.SetUSUARIOIsNull(const aValue: Boolean);
begin
  if aValue then
    DataTable.Fields[idx_ComisionesUSUARIO].AsVariant := Null;
end;


initialization
  RegisterDataTableRules(RID_Facturas_Comision, TFacturas_ComisionDataTableRules);
  RegisterDataTableRules(RID_Vendedores_Comision, TVendedores_ComisionDataTableRules);
  RegisterDataTableRules(RID_Comisiones, TComisionesDataTableRules);

end.
